#ifndef __MACH_ATMEL_HLCD_OVL_H__
#define __MACH_ATMEL_HLCD_OVL_H__

/*
 * OVL has a seperate resource which already starts at offset 0x100.
 * So, these defines start at 0x0. The manual will list them at 0x100.
 */

#define ATMEL_LCDC_OVRCHER1	0x0000
#define LCDC_OVRCHER1_CHEN		(0x1 << 0)
#define LCDC_OVRCHER1_UPDATEEN		(0x1 << 1)
#define LCDC_OVRCHER1_A2QEN		(0x1 << 2)

#define ATMEL_LCDC_OVRCHDR1	0x0004
#define LCDC_OVRCHDR1_CHDIS		(0x1 << 0)
#define LCDC_OVRCHDR1_CHRST		(0x1 << 8)

#define ATMEL_LCDC_OVRCHSR1	0x0008
#define LCDC_OVRCHSR1_CHSR		(0x1 << 0)
#define LCDC_OVRCHSR1_UPDATESR		(0x1 << 1)
#define LCDC_OVRCHSR1_A2QSR		(0x1 << 2)

#define ATMEL_LCDC_OVRIER1	0x000C
#define LCDC_OVRIER1_DMA		(0x1 << 2)
#define LCDC_OVRIER1_DSCR		(0x1 << 3)
#define LCDC_OVRIER1_ADD		(0x1 << 4)
#define LCDC_OVRIER1_DONE		(0x1 << 5)
#define LCDC_OVRIER1_OVR		(0x1 << 6)

#define ATMEL_LCDC_OVRIDR1	0x0010
#define LCDC_OVRIDR1_DMA		(0x1 << 2)
#define LCDC_OVRIDR1_DSCR		(0x1 << 3)
#define LCDC_OVRIDR1_ADD		(0x1 << 4)
#define LCDC_OVRIDR1_DONE		(0x1 << 5)
#define LCDC_OVRIDR1_OVR		(0x1 << 6)

#define ATMEL_LCDC_OVRIMR1	0x0014
#define LCDC_OVRIMR1_DMA		(0x1 << 2)
#define LCDC_OVRIMR1_DSCR		(0x1 << 3)
#define LCDC_OVRIMR1_ADD		(0x1 << 4)
#define LCDC_OVRIMR1_DONE		(0x1 << 5)
#define LCDC_OVRIMR1_OVR		(0x1 << 6)

#define ATMEL_LCDC_OVRISR1	0x0018
#define LCDC_OVRISR1_DMA		(0x1 << 2)
#define LCDC_OVRISR1_DSCR		(0x1 << 3)
#define LCDC_OVRISR1_ADD		(0x1 << 4)
#define LCDC_OVRISR1_DONE		(0x1 << 5)
#define LCDC_OVRISR1_OVR		(0x1 << 6)

#define ATMEL_LCDC_OVRHEAD1	0x001C

#define ATMEL_LCDC_OVRADDR1	0x0020

#define ATMEL_LCDC_OVRCTRL1	0x0024
#define LCDC_OVRCTRL1_DFETCH		(0x1 << 0)
#define LCDC_OVRCTRL1_LFETCH		(0x1 << 1)
#define LCDC_OVRCTRL1_DMAIEN		(0x1 << 2)
#define LCDC_OVRCTRL1_DSCRIEN		(0x1 << 3)
#define LCDC_OVRCTRL1_ADDIEN		(0x1 << 4)
#define LCDC_OVRCTRL1_DONEIEN		(0x1 << 5)

#define ATMEL_LCDC_OVRNEXT1	0x0028

#define ATMEL_LCDC_OVR1CFG0	0x002C
#define LCDC_OVR1CFG0_BLEN_OFFSET	4
#define LCDC_OVR1CFG0_BLEN		(0x3 << LCDC_OVR1CFG0_BLEN_OFFSET)
#define		LCDC_OVR1CFG0_BLEN_AHB_SINGLE		(0x0 << 4)
#define		LCDC_OVR1CFG0_BLEN_AHB_INCR4		(0x1 << 4)
#define		LCDC_OVR1CFG0_BLEN_AHB_INCR8		(0x2 << 4)
#define		LCDC_OVR1CFG0_BLEN_AHB_INCR16		(0x3 << 4)
#define LCDC_OVR1CFG0_DLBO		(0x1 << 8)
#define LCDC_OVR1CFG0_ROTDIS		(0x1 << 12)
#define LCDC_OVR1CFG0_LOCKDIS		(0x1 << 13)

#define ATMEL_LCDC_OVR1CFG1	0x0030
#define LCDC_OVR1CFG1_CLUTEN		(0x1 << 0)
#define LCDC_OVR1CFG1_RGBMODE_OFFSET	4
#define LCDC_OVR1CFG1_RGBMODE		(0xf << LCDC_OVR1CFG1_RGBMODE_OFFSET)
#define		LCDC_OVR1CFG1_RGBMODE_12BPP_RGB_444	(0x0 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_16BPP_ARGB_4444	(0x1 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_16BPP_RGBA_4444	(0x2 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_16BPP_RGB_565	(0x3 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_16BPP_TRGB_1555	(0x4 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_18BPP_RGB_666	(0x5 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_18BPP_RGB_666_PACKED	(0x6 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_19BPP_TRGB_1666	(0x7 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_19BPP_TRGB_PACKED	(0x8 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_24BPP_RGB_888	(0x9 << 4)
#define		LCDC_OVR1CFG1_RGBMODE_24BPP_RGB_888_PACKED	(0xA << 4)
#define		LCDC_OVR1CFG1_RGBMODE_25BPP_TRGB_1888	(0xB << 4)
#define		LCDC_OVR1CFG1_RGBMODE_32BPP_ARGB_8888	(0xC << 4)
#define		LCDC_OVR1CFG1_RGBMODE_32BPP_RGBA_8888	(0xD << 4)
#define LCDC_OVR1CFG1_CLUTMODE_OFFSET	8
#define LCDC_OVR1CFG1_CLUTMODE		(0x3 << LCDC_OVR1CFG1_CLUTMODE_OFFSET)
#define		LCDC_OVR1CFG1_CLUTMODE_1BPP		(0x0 << 8)
#define		LCDC_OVR1CFG1_CLUTMODE_2BPP		(0x1 << 8)
#define		LCDC_OVR1CFG1_CLUTMODE_4BPP		(0x2 << 8)
#define		LCDC_OVR1CFG1_CLUTMODE_8BPP		(0x3 << 8)

#define ATMEL_LCDC_OVR1CFG2	0x0034
#define LCDC_OVR1CFG2_XOFFSET_OFFSET	0
#define LCDC_OVR1CFG2_XOFFSET		(0x7ff << LCDC_OVR1CFG2_XOFFSET_OFFSET)
#define LCDC_OVR1CFG2_YOFFSET_OFFSET	16
#define LCDC_OVR1CFG2_YOFFSET		(0x7ff << LCDC_OVR1CFG2_YOFFSET_OFFSET)

#define ATMEL_LCDC_OVR1CFG3	0x0038
#define LCDC_OVR1CFG3_XSIZE_OFFSET	0
#define LCDC_OVR1CFG3_XSIZE		(0x7ff << LCDC_OVR1CFG3_XSIZE_OFFSET)
#define LCDC_OVR1CFG3_YSIZE_OFFSET	16
#define LCDC_OVR1CFG3_YSIZE		(0x7ff << LCDC_OVR1CFG3_YSIZE_OFFSET)

#define ATMEL_LCDC_OVR1CFG4	0x003C

#define ATMEL_LCDC_OVR1CFG5	0x0040

#define ATMEL_LCDC_OVR1CFG6	0x0044
#define LCDC_OVR1CFG6_BDEF_OFFSET	0
#define LCDC_OVR1CFG6_BDEF		(0xff << LCDC_OVR1CFG6_BDEF_OFFSET)
#define LCDC_OVR1CFG6_GDEF_OFFSET	8
#define LCDC_OVR1CFG6_GDEF		(0xff << LCDC_OVR1CFG6_GDEF_OFFSET)
#define LCDC_OVR1CFG6_RDEF_OFFSET	16
#define LCDC_OVR1CFG6_RDEF		(0xff << LCDC_OVR1CFG6_RDEF_OFFSET)

#define ATMEL_LCDC_OVR1CFG7	0x0048
#define LCDC_OVR1CFG7_BKEY_OFFSET	0
#define LCDC_OVR1CFG7_BKEY		(0xff << LCDC_OVR1CFG7_BKEY_OFFSET)
#define LCDC_OVR1CFG7_GKEY_OFFSET	8
#define LCDC_OVR1CFG7_GKEY		(0xff << LCDC_OVR1CFG7_GKEY_OFFST)
#define LCDC_OVR1CFG7_RKEY_OFFSET	16
#define LCDC_OVR1CFG7_RKEY		(0xff << LCDC_OVR1CFG7_RKEY_OFFSET)

#define ATMEL_LCDC_OVR1CFG8	0x004C
#define LCDC_OVR1CFG8_BMASK_OFFSET	0
#define LCDC_OVR1CFG8_BMASK		(0xff << LCDC_OVR1CFG8_BMASK_OFFSET)
#define LCDC_OVR1CFG8_GMASK_OFFSET	8
#define LCDC_OVR1CFG8_GMASK		(0xff << LCDC_OVR1CFG8_GMASK_OFFSET)
#define LCDC_OVR1CFG8_RMASK_OFFSET	16
#define LCDC_OVR1CFG8_RMASK		(0xff << LCDC_OVR1CFG8_RMASK_OFFSET)

#define ATMEL_LCDC_OVR1CFG9	0x0050
#define LCDC_OVR1CFG9_CRKEY		(0x1 << 0)
#define LCDC_OVR1CFG9_INV		(0x1 << 1)
#define LCDC_OVR1CFG9_ITER2BL		(0x1 << 2)
#define LCDC_OVR1CFG9_ITER		(0x1 << 3)
#define LCDC_OVR1CFG9_REVALPHA		(0x1 << 4)
#define LCDC_OVR1CFG9_GAEN		(0x1 << 5)
#define LCDC_OVR1CFG9_LAEN		(0x1 << 6)
#define LCDC_OVR1CFG9_OVR		(0x1 << 7)
#define LCDC_OVR1CFG9_DMA		(0x1 << 8)
#define LCDC_OVR1CFG9_REP		(0x1 << 9)
#define LCDC_OVR1CFG9_DSTKEY		(0x1 << 10)
#define LCDC_OVR1CFG9_GA_OFFSET		16
#define LCDC_OVR1CFG9_GA		(0xff << LCDC_OVR1CFG9_GA_OFFSET)

#endif /* __MACH_ATMEL_HLCD_OVL_H__ */
